﻿namespace Falcon.SugarApi.FalconCors
{
    /// <summary>
    /// 跨域请求cors参数
    /// </summary>
    public class CorsOptions
    {
        /// <summary>
        /// 策略名
        /// </summary>
        public string? PolicyName { get; set; }
        /// <summary>
        /// 允许通过的方法。
        /// </summary>
        public string? Methods { get; set; }
        /// <summary>
        /// 允许通过的请求头
        /// </summary>
        public string? Headers { get; set; }
        /// <summary>
        /// 运行通过的源
        /// </summary>
        public string? Origins { get; set; }
        /// <summary>
        /// 允许携带凭据
        /// </summary>
        public bool? AllowCredentials { get; set; }
    }
}
