﻿using System;

namespace Falcon.SugarApi.Plugin.Service
{
    /// <summary>
    /// 插件执行AddServices方法时发生错误
    /// </summary>
    public class PluginExecAddServicesException:Exception
    {
        /// <summary>
        /// 通过插件类型和异常类型引发异常
        /// </summary>
        /// <param name="type">插件注册类型</param>
        /// <param name="innExecption">已发的异常</param>
        public PluginExecAddServicesException(Type type,Exception innExecption)
            : base($"调用插件{type.FullName}.IServicePlugin.AddServices]方法时发生异常。",innExecption) {
        }
    }
}
